"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceNgOnInit = exports.IVY_PROTOTYPE = exports.IVY_ON_INIT = exports.NG_ON_INIT = void 0;
exports.NG_ON_INIT = 'ngOnInit';
exports.IVY_ON_INIT = 'onInit';
exports.IVY_PROTOTYPE = 'ɵcmp';
function replaceNgOnInit(proto, fn) {
    var target = proto.constructor;
    var onInitName = exports.NG_ON_INIT;
    if (target[exports.IVY_PROTOTYPE]) {
        proto = target[exports.IVY_PROTOTYPE];
        onInitName = exports.IVY_ON_INIT;
    }
    var origNgOnInit = proto[onInitName];
    if (!origNgOnInit) {
        throw new Error('ngOnInit() should exist on the component, otherwise the decorator will not work with the AOT compiler!!');
    }
    proto[onInitName] = function () {
        fn.call(this);
        origNgOnInit.call(this);
    };
}
exports.replaceNgOnInit = replaceNgOnInit;
